#include <stdio.h>
#include <string.h>
#include "tree.h"

typedef struct env *ENV;

struct env
{ char *id;
  int val;
  ENV next;
  };

static int eval(TREE,ENV);

static int lookup(char *i,ENV e)
{ while (e!=NULL)
  { if (strcmp(i,e->id)==0)
        return(e->val);
    e=e->next;
  }
  printf("Warning: undeclared identifier %s treated as 0\n",i);
  return(0);
}

static ENV extend(TREE t,ENV e)
{ ENV new;
  switch (class_of_tree(t))
  { case andnode:
        return(extend(right_child(t),extend(left_child(t),e)));
    case eqnode:
        new=(ENV)malloc(sizeof(struct env));
        new->id=string_of_eq_tree(t);
        new->val=eval(only_child(t),e);
        new->next=e;
        return(new);
    default:
        printf("Invalid deflist tree passed to extend function\n");
        printf("There must be a bug in the parser!\n");
        exit(1);
   }
}

static int eval(TREE t,ENV e)
{ switch (class_of_tree(t))
  { case letnode:
        return(eval(rght_child(t),extend(left_child(t),e)));
    case plusnode:
        return(eval(left_child(t),e)+eval(right_child(t),e));
    case timesnode:
        return(eval(left_child(t),e)*eval(right_child(t),e));
    case minusnode:
        return(-eval(only_child(t),e));
    case idnode:
        return(lookup(string_of_id_leaf(t),e));
    case numnode:
        return(num_of_number_leaf(t));
    default:
        printf("Invalid expression tree passed to eval function\n");
        printf("There must be a bug in the parser!\n");
        exit(1);
  }
}

int interpret(TREE t)
{
    return(eval(t,NULL));
}

  }


}
